package com.brilliance.isc.funds.common.controller;

import com.brilliance.isc.bo.Bopcod;
import com.brilliance.isc.common.api.bopcod.BopcodService;
import com.brilliance.isc.vo.ResponseSet;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("/bopcod")
public class BopcodController {
    @Autowired
    private BopcodService bopcodService;

    
    @RequestMapping("/getBopcodList")
    public ResponseSet<List<Bopcod>> getBopcodList(@RequestBody Map<String,Object> body){
        String iotyp = body.get("iotyp").toString();
        return new ResponseSet(bopcodService.getBopcodList(iotyp));
    }
}
