package com.brilliance.isc.funds.fxtfcm.register.settle;

import com.brilliance.isc.common.glemod.service.GlemodService;
import com.brilliance.isc.common.register.settle.DefaultSettleRegister;
import com.brilliance.isc.common.register.settle.ISettleRegister;
import com.brilliance.isc.common.setglg.service.SetglgService;
import com.brilliance.isc.common.setmod.service.SetmodService;
import com.brilliance.isc.common.setmod.vo.SetmodVo;
import com.brilliance.isc.vo.funds.FxdBizInfoVo;
import com.brilliance.mda.runtime.mda.util.Decimals;
import com.brilliance.mda.runtime.mda.util.MdaUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.math.BigDecimal;

@Component("fxtfcm.settleRegister")
public class FxtfcmSettleRegister implements ISettleRegister {

    @Autowired
    private SetmodService setmodService;
    @Autowired
    private SetglgService setglgService;
    @Autowired
    private DefaultSettleRegister defaultSettleRegister;
    @Autowired
    private GlemodService glemodService;

    @Override
    public void registerSettlement(SetmodVo setmodVo) {
        transRegister(setmodVo);
        defaultSettleRegister.registerSettlement(setmodVo);
    }

    private void transRegister(SetmodVo setmodVo) {
//        FxdBizInfoVo rec = (FxdBizInfoVo) setmodVo.getRec();
//
//        setglgService.setglgClrAmount ( setmodVo.getSetglg(),"TRN" );
//        setglgService.setglgClrAmount ( setmodVo.getSetglg(),"SET" );
//        //!==============================================
//        //2、付出外币资金：
//        //借：281105外汇买卖对外平盘   （A外币）
//        //贷：112306/1125存放境内/外同业  （A外币）
//        //!==============================================
//        String act1 = null;
//        String dbtKey = null;
//        String acctyp = null;
//        String acc = null;
//        String cdtKey = null;
//        BigDecimal baseunit = null;
//        if(  ! MdaUtils.isEmpty(rec.getFxtyp()) )
//        {
//            //#卖出确认
//            //D:281105(A外币)
//            act1 = glemodService.getAvailAcc ( "FT-FCR", this.getFxdgrp().getCbs().getNom1().getCur(), "", this, setmodVo.getSetamt() );
//            dbtKey = setglgService.setglgAddAmount ( setmodVo.getSetglg(),"SET", "APL", this.getSetmod().getDoccur(), setmodVo.getSetamt(), "SET", "FTD", "F", act1, "SET" );
//            /**
//             $Act1 = SETMOD\\GLEMOD.GetAvailAcc ( "FX-ELQ", FXDGRP\\CBS\\MAX\\CUR, "", self, SETMOD\\SETAMT )
//             $DbtKey = \\SETMOD\\SETGLG.SetglgAddAmount ( "SET", "OWN", SETMOD\\DOCCUR, SETMOD\\SETAMT, "SET", "FXD", "F", $Act1, "SET" )
//
//             **/
//            // cz modify 增加中间中间账户
//            if( this.getFxdgrp().getAct().isRolSet() )
//            {
//                if( this.getFxdgrp().getAct().isDemestic() )
//                {
//                    acctyp = "DB-CLR";
//                    acc = this.getSetmod().getGlemod().getAvailAcc ( acctyp, this.getSetmod().getDoccur(), this.getFxdgrp().getAct().getPts().getPtyinr(), this, setmodVo.getSetamt() );
//                    cdtKey = this.getSetmod().getSetglg().setglgAddAmount ( "SET", "APL", this.getSetmod().getDoccur(), setmodVo.getSetamt().negate(), "", "DBC", "C", acc, "" );
//                }
//                else
//                {
//                    acctyp = "DB-FOG";
//                    acc = this.getSetmod().getGlemod().getAvailAcc ( acctyp, this.getSetmod().getDoccur(), this.getFxdgrp().getAct().getPts().getPtyinr(), this, setmodVo.getSetamt() );
//                    cdtKey = this.getSetmod().getSetglg().setglgAddAmount ( "SET", "APL", this.getSetmod().getDoccur(), setmodVo.getSetamt().negate(), "", "PAC", "C", acc, "" );
//                }
//            }
//            else
//            {
//                if( this.getFxdgrp().getApl().isDemestic() )
//                {
//                    acctyp = "DB-CLR";
//                    acc = this.getSetmod().getGlemod().getAvailAcc ( acctyp, this.getSetmod().getDoccur(), this.getFxdgrp().getApl().getPts().getPtyinr(), this, setmodVo.getSetamt() );
//                    cdtKey = this.getSetmod().getSetglg().setglgAddAmount ( "SET", "APL", this.getSetmod().getDoccur(), setmodVo.getSetamt().negate(), "", "DBC", "C", acc, "" );
//                }
//                else
//                {
//                    acctyp = "DB-FOG";
//                    acc = this.getSetmod().getGlemod().getAvailAcc ( acctyp, this.getSetmod().getDoccur(), this.getFxdgrp().getApl().getPts().getPtyinr(), this, setmodVo.getSetamt() );
//                    cdtKey = this.getSetmod().getSetglg().setglgAddAmount ( "SET", "APL", this.getSetmod().getDoccur(), setmodVo.getSetamt().negate(), "", "PAC", "C", acc, "" );
//                }
//            }
//            //C:112306/1125外币
//            //如果ACT未赋值，则APL为我行的账户行
//            setglgService.setglgAddAmtFldAccCur ( setmodVo.getSetglg(),"SET", dbtKey, this.getFxdgrp().getCbs().getNom1().getCur() );
//            baseunit = Dynamic.crossRatebas( this.getFxdgrp().getCbs().getMax().getCur(), this.getFxdgrp().getCbs().getNom1().getCur() );
//            setglgService.setglgAddAmtFldExtRat ( "SET", dbtKey, Decimals.mul(1.00,baseunit), this.getFxdgrp().getRec().getRat() );
//        }
//        this.getSetmod().setglgAllValDat ( this.getFxdgrp().getRec().getValdat(), "D" );
    }
}
