package com.brilliance.isc.funds.bo.funds;

import com.brilliance.isc.bo.model.Fxdgrp;
import com.brilliance.isc.bo.model.Fxtp;
import com.brilliance.isc.common.transaction.vo.BaseTransactionVo;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import lombok.Data;

/**
 * @program: isc-funds
 * @ClassName: FxtsssStoreBo
 * @description: 即期结汇bo
 * @author: huangshunlin
 * @create: 2024-10-08 15:51
 */
@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class FxtsssStoreBo extends BaseTransactionVo {
    private Fxdgrp fxdgrp;

    private Fxtp fxtp;

    @Override
    public void reset() {
        super.reset();
        if (fxdgrp == null) {
            fxdgrp = new Fxdgrp();
        }
        fxdgrp.reset();
        if (fxtp == null) {
            fxtp = new Fxtp();
        }
        fxtp.reset();
    }
}
